package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {
    private String[][] board;
    private Integer value;
    private Integer rowIndex;
    private Integer columnIndex;

    public TicTacToe() {
    }

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[][] getBoard() {
        return board;
    }

    public void setBoard(String[][] board) {
        this.board = board;
    }

    public Integer getValue() {
        return value;
    }

    public void setValue(Integer value) {
        this.value = value;
    }

    public Integer getRowIndex() {
        return rowIndex;
    }

    public void setRowIndex(Integer rowIndex) {
        this.rowIndex = rowIndex;
    }

    public Integer getColumnIndex() {
        return columnIndex;
    }

    public void setColumnIndex(Integer columnIndex) {
        this.columnIndex = columnIndex;
    }

    public String[] getRow(Integer value) {
        return board[value];
    }

    public String[] getColumn(Integer value) {
        String[] str = new String[3];

        return null;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {

        for (int i = 1; i < 3; i++) {
            if (this.board[rowIndex][i] != this.board[rowIndex][i - 1]) {
                return false;
            }
        }

        return true;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        for (int i = 1; i < 3; i++) {
            if (this.board[i][columnIndex] != this.board[i - 1][columnIndex]) {
                return false;
            }
        }

        return true;
    }

    public String getWinner() {
        Integer count = 0;
        //rows
        for (int i = 0; i < 3; i++) {
            if (board[i][0] == board[i][1] && board[i][0] == board[i][2]) {
                return board[i][0];
            }
        }
        //columns
        for (int i = 0; i < 3; i++) {
            if (board[0][i] == board[1][i] && board[0][i] == board[2][i]) {
                return board[0][i];
            }
            //diagonal1
            if (i == 2 && board[i][i] == board[i - 1][i - 1] && board[i][i] == board[i - 2][i - 2]) {
                return board[i][i];
            }
        }
        //diagonal2
            if (board[0][2] == board[1][1] && board[0][2] == board[2][0]){
            return board[0][2];
        }

        return null;
    }
}
